<template>
  <div>
    <gpa-main-menu />

    <router-view v-if="ready" />
    <rui-loading v-else fill>
      <strong>{{ $t('generic.loading_general_data') }}</strong>
      <div v-for="entry in loadingEntries" :key="entry.key">{{ entry.message }}</div>
    </rui-loading>

    <rui-modal v-if="showResourcePickerFor"
               :caption="$t('js.patches.index.resource_selection')"
               :cancellable="true"
               :acceptable="false"
               @cancel="showResourcePickerFor = null"
               @close="showResourcePickerFor = null">
      <gpa-resource-selector :patch="showResourcePickerFor"
                             @done="showResourcePickerFor = null" />
    </rui-modal>

    <!-- Data Modals -->
    <rui-modal v-if="showObservationsFor"
               :caption="$t('js.observations.list.title')"
               :cancellable="false"
               :large="true"
               @accept="showObservationsFor = null"
               @close="showObservationsFor = null">
      <gpa-observations :subject="showObservationsFor" :editable="true" />
    </rui-modal>

    <rui-modal v-if="showResourceDescriptionFor"
               :caption="showResourceDescriptionFor.name"
               :cancellable="false"
               large
               @close="showResourceDescriptionFor = null"
               @accept="showResourceDescriptionFor = null">
      <gpa-resource :resource="showResourceDescriptionFor" :show-title="false" />
    </rui-modal>

    <rui-modal v-if="showHarvestsFor"
               :caption="showHarvestsFor.displayName"
               :cancellable="false"
               large
               @close="showHarvestsFor = null"
               @accept="showHarvestsFor = null">
      <gpa-element-harvests :element="showHarvestsFor" :editable="true" />
    </rui-modal>

    <!-- Library forms -->
    <rui-modal v-if="showFamilyFormFor !== false"
               :caption="showFamilyFormFor ? $t('js.families.form.title_edit') : $t('js.families.form.title_new')"
               no-footer
               @close="showFamilyFormFor = false">
      <gpa-family-form :family="showFamilyFormFor"
                       @saved="showFamilyFormFor = false"
                       @cancel="showFamilyFormFor = false" />
    </rui-modal>

    <rui-modal v-if="showGenusFormFor !== false"
               :caption="showGenusFormFor ? $t('js.genera.form.title_edit') : $t('js.genera.form.title_new')"
               no-footer
               @close="showGenusFormFor = false">
      <gpa-genera-form :genus="showGenusFormFor"
                       @saved="showGenusFormFor = false"
                       @cancel="showGenusFormFor = false" />
    </rui-modal>

    <rui-modal v-if="showResourceFormFor !== false"
               :caption="showResourceFormFor ? $t('js.resources.form.title_edit') : $t('js.resources.form.title_new')"
               no-footer
               @close="showResourceFormFor = false">
      <gpa-resource-form :resource="showResourceFormFor"
                         @saved="showResourceFormFor = false"
                         @cancel="showResourceFormFor = false" />
    </rui-modal>

    <rui-modal v-if="showResourceNoteFormFor !== false"
               :caption="showResourceNoteFormFor.id ? $t('js.resource_note.form.title_edit') : $t('js.resource_note.form.title_new')"
               no-footer
               @close="showResourceNoteFormFor = false">
      <gpa-resource-note-form :resource-note="showResourceNoteFormFor"
                              @saved="showResourceNoteFormFor = false"
                              @cancel="showResourceNoteFormFor = false" />
    </rui-modal>

    <rui-modal v-if="showResourceInteractionFormFor !== false"
               :caption="showResourceInteractionFormFor.id ? $t('js.resource_interaction.form.title_edit') : $t('js.resource_interaction.form.title_new')"
               no-footer
               @close="showResourceInteractionFormFor = false">
      <gpa-resource-interactions-form :resource-interaction="showResourceInteractionFormFor.resourceInteraction"
                                      :subject-id="showResourceInteractionFormFor.subjectId"
                                      :show-title="false"
                                      @saved="showResourceInteractionFormFor = false"
                                      @cancel="showResourceInteractionFormFor = false" />
    </rui-modal>

    <rui-modal v-if="showResourceInteractionsGroupFormFor !== false"
               :caption="showResourceInteractionsGroupFormFor ? $t('js.resource_interactions_group.form.title_edit') : $t('js.resource_interactions_group.form.title_new')"
               no-footer
               @close="showResourceInteractionsGroupFormFor = false">
      <gpa-resource-interactions-group-form :resource-interactions-group="showResourceInteractionsGroupFormFor"
                                            @saved="showResourceInteractionsGroupFormFor = false"
                                            @cancel="showResourceInteractionsGroupFormFor = false" />
    </rui-modal>

    <!-- Layer forms -->
    <rui-modal v-if="showLayerFormFor !== false"
               :caption="showLayerFormFor ? $t('js.layers.form.title_edit') : $t('js.layers.form.title_new')"
               no-footer
               @close="showLayerFormFor = false">
      <gpa-layer-form :layer="showLayerFormFor"
                      @saved="showLayerFormFor = false"
                      @cancel="showLayerFormFor = false" />
    </rui-modal>

    <!-- Map forms -->
    <rui-modal v-if="showMapNotesFormFor"
               :caption="$t('activerecord.attributes.map.notes')"
               no-footer
               @accept="showMapNotesFormFor = null"
               @close="showMapNotesFormFor = null">
      <gpa-map-note-form :map="showMapNotesFormFor"
                         @cancel="showMapNotesFormFor = null"
                         @done="showMapNotesFormFor = null" />
    </rui-modal>

    <!-- Elements forms -->
    <rui-modal v-if="showElementFormFor"
               :caption="$t('js.element.form.title')"
               no-footer
               @close="showElementFormFor = null">
      <gpa-element-form :element="showElementFormFor"
                        @cancel="showElementFormFor = null"
                        @saved="showElementFormFor = null" />
    </rui-modal>

    <rui-modal v-if="showImplantationFormFor"
               :caption="$t('js.element.implantation_form.title')"
               no-footer
               @close="showImplantationFormFor = null">
      <gpa-element-implantation-form :element="showImplantationFormFor"
                                     @saved="showImplantationFormFor = null"
                                     @cancel="showImplantationFormFor = null" />
    </rui-modal>

    <rui-modal v-if="showRemovalFormFor"
               :caption="$t('js.element.removal_form.title')"
               no-footer
               @close="showRemovalFormFor = null">
      <gpa-element-removal-form :element="showRemovalFormFor"
                                @saved="showRemovalFormFor = null"
                                @cancel="showRemovalFormFor = null" />
    </rui-modal>

    <!-- Patch forms -->
    <rui-modal v-if="showPatchFormFor"
               :caption="$t('js.patches.form.title.update')"
               no-footer
               @close="showPatchFormFor = null">
      <gpa-patch-form :patch="showPatchFormFor"
                      @cancel="showPatchFormFor = null"
                      @saved="showPatchFormFor = null" />
    </rui-modal>
    <rui-modal v-if="showPatchPickerFor"
               :caption="$t('js.patches.index.patch_selection')"
               :cancellable="true"
               :acceptable="false"
               @cancel="showPatchPickerFor = null"
               @close="showPatchPickerFor = null">
      <gpa-patch-selector @choose="selectPatchFromPicker" />
    </rui-modal>

    <!-- Path forms -->
    <rui-modal v-if="showPathFormFor"
               :caption="$t('js.paths.form.title')"
               no-footer
               @close="showPathFormFor = null">
      <gpa-path-form :path="showPathFormFor"
                     @cancel="showPathFormFor = null"
                     @saved="showPathFormFor = null" />
    </rui-modal>

    <!-- Observations forms -->
    <rui-modal v-if="showObservationFormFor"
               :caption="showObservationFormFor.className === 'Observation' ? $t('js.observations.form.edit_title') : $t('js.observations.form.new_title')"
               no-footer
               @close="showObservationFormFor = null">
      <gpa-observation-form :subject="showObservationFormFor.className !== 'Observation' ? showObservationFormFor : null"
                            :observation="showObservationFormFor.className === 'Observation' ? showObservationFormFor : null"
                            @done="showObservationFormFor = null"
                            @cancel="showObservationFormFor = null" />
    </rui-modal>

    <!-- Harvest forms -->
    <rui-modal v-if="showHarvestFormFor"
               :caption="$t('js.harvests.form.title')"
               no-footer
               @accept="showHarvestFormFor = null"
               @close="showHarvestFormFor = null">
      <gpa-harvest-form :element="showHarvestFormFor.className === 'Element' ? showHarvestFormFor : null"
                        :harvest="showHarvestFormFor.className === 'Harvest' ? showHarvestFormFor : null"
                        @cancel="showHarvestFormFor = null"
                        @done="showHarvestFormFor = null" />
    </rui-modal>

    <!-- Tasks forms -->
    <rui-modal v-if="showTaskFormFor"
               :caption="$t('js.tasks.form.title')"
               no-footer
               @close="showTaskFormFor = null">
      <gpa-task-form :subject="showTaskFormFor"
                     @done="showTaskFormFor = null"
                     @cancel="showTaskFormFor = null" />
    </rui-modal>

    <!-- Other widgets -->
    <rui-modal v-if="showNotificationsModal" :caption="$t('js.notifications.list.title')" no-footer @close="showNotificationsModal = false">
      <gpa-notifications />
    </rui-modal>

    <gp-details-from-route />

    <rui-image-viewer v-if="imageToDisplay" :list="imagesList" :preselected="imageToDisplay" @close="imageToDisplay = null" />

    <rui-confirm-dialog v-if="confirmDialogOptions"
                        :caption="confirmDialogOptions.caption"
                        :message="confirmDialogOptions.message"
                        @accept="acceptConfirmDialog"
                        @reject="confirmDialogOptions = null">
      <component :is="confirmDialogOptions.component" v-if="confirmDialogOptions?.component" />
    </rui-confirm-dialog>

    <rui-confirm-dialog v-if="informationModalOptions"
                        :caption="informationModalOptions.caption"
                        :message="informationModalOptions.message"
                        :acceptable="informationModalOptions.acceptable"
                        :rejectable="informationModalOptions.rejectable"
                        @accept="informationModalOptions = null"
                        @reject="informationModalOptions = null" />
  </div>
</template>

<script>
import RuiImageViewer from '@experiments-labs/rise_ui/src/components/DataDisplay/ImageViewer/ImageViewer.vue'
import RuiLoading from '@experiments-labs/rise_ui/src/components/Loading/Loading.vue'
import RuiConfirmDialog from '@experiments-labs/rise_ui/src/components/Modal/ConfirmDialog.vue'
import RuiModal from '@experiments-labs/rise_ui/src/components/Modal/Modal.vue'

// App components
import GpDetailsFromRoute from '../../common/_DetailsFromRoute.vue'
import GpaElementForm from './components/Elements/_Form.vue'
import GpaElementHarvests from './components/Harvests/_ElementHarvests.vue'
import GpaElementImplantationForm from './components/Elements/_ImplantationForm.vue'
import GpaElementRemovalForm from './components/Elements/_RemovalForm.vue'
import GpaFamilyForm from './components/Family/_Form.vue'
import GpaGeneraForm from './components/Genera/_Form.vue'
import GpaHarvestForm from './components/Harvests/_Form.vue'
import GpaLayerForm from './components/Layers/_Form.vue'
import GpaMainMenu from './components/Layouts/_MainMenu.vue'
import GpaMapNoteForm from './components/Maps/_NotesForm.vue'
import GpaNotifications from './components/Notifications/_List.vue'
import GpaObservationForm from './components/Observations/_Form.vue'
import GpaObservations from './components/Observations/_Observations.vue'
import GpaPatchForm from './components/Patches/_Form.vue'
import GpaPathForm from './components/Paths/_Form.vue'
import GpaResourceForm from './components/Resources/_Form.vue'
import GpaResource from './components/Resources/_Resource.vue'
import GpaResourceNoteForm from './components/ResourceNotes/_Form.vue'
import GpaResourceSelector from './components/Resources/Selector/Selector.vue'
import GpaTaskForm from './components/Tasks/_Form.vue'
import GpaResourceInteractionsGroupForm from './components/ResourceInteractionsGroup/_Form.vue'
import GpaResourceInteractionsForm from './components/ResourceInteractions/_Form.vue'
import GpaPatchSelector from './components/Patches/_Selector.vue'

/**
 * @typedef {import('../../classes/models/Element')}      Element
 * @typedef {import('../../classes/models/Family')}       Family
 * @typedef {import('../../classes/models/Genus')}        Genus
 * @typedef {import('../../classes/models/Harvest')}      Harvest
 * @typedef {import('../../classes/models/Layer')}        Layer
 * @typedef {import('../../classes/models/Map')}          Map
 * @typedef {import('../../classes/models/Observation')}  Observation
 * @typedef {import('../../classes/models/Patch')}        Patch
 * @typedef {import('../../classes/models/Path')}         Path
 * @typedef {import('../../classes/models/Resource')}     Resource
 * @typedef {import('../../classes/models/ResourceInteractionsGroup')} ResourceInteractionsGroup
 * @typedef {import('../../classes/models/ResourceInteraction')}      ResourceInteraction
 * @typedef {import('../../classes/models/ResourceNote')} ResourceNote
 */

export default {
  name: 'GardenApplication',
  components: {
    GpDetailsFromRoute,
    RuiImageViewer,
    RuiConfirmDialog,
    RuiModal,
    RuiLoading,
    GpaElementHarvests,
    GpaHarvestForm,
    GpaResourceInteractionsGroupForm,
    GpaPatchSelector,
    GpaResourceInteractionsForm,
    GpaElementForm,
    GpaElementImplantationForm,
    GpaElementRemovalForm,
    GpaFamilyForm,
    GpaGeneraForm,
    GpaLayerForm,
    GpaMainMenu,
    GpaMapNoteForm,
    GpaNotifications,
    GpaObservationForm,
    GpaObservations,
    GpaPatchForm,
    GpaPathForm,
    GpaResource,
    GpaResourceForm,
    GpaResourceNoteForm,
    GpaResourceSelector,
    GpaTaskForm,
  },
  data () {
    return {
      ready: false,
      confirmDialogOptions: null,
      informationModalOptions: null,
      // Family form
      showFamilyFormFor: false,
      // Genus form
      showGenusFormFor: false,
      // Resource form
      showResourceFormFor: false,
      showResourceNoteFormFor: false,
      /** @type {{resourceInteraction: ResourceInteraction | null, resourceId: number | null} | false} Resource interaction form */
      showResourceInteractionFormFor: false,
      // Resource interaction group form
      showResourceInteractionsGroupFormFor: false,
      // Layer form
      showLayerFormFor: false,
      // Observation form
      showObservationFormFor: null,
      // Harvest form
      /** @type {Harvest|Element|null} */
      showHarvestFormFor: null,
      /** @type {Element|null} */
      showHarvestsFor: null,
      // Task form
      showTaskFormFor: null,
      // Element forms
      showElementFormFor: null,
      showImplantationFormFor: null,
      showRemovalFormFor: null,
      // Patch
      showPatchFormFor: null,
      /**
       * @callback            showPatchPickerCallback
       * @param {Patch} patch - Picked patch
       */
      /** @type {showPatchPickerCallback|null} - Callback for the patch picker */
      showPatchPickerFor: null,
      /** @type {Patch|null} */
      showResourcePickerFor: null,
      // Path form
      showPathFormFor: null,
      // Map forms
      showMapNotesFormFor: null,

      // Image viewer
      imagesList: [],
      imageToDisplay: null,
      // Other modals
      showObservationsFor: null,
      showResourceDescriptionFor: null,
      showNotificationsModal: false,
    }
  },
  computed: {
    loadingEntries () { return this.$store.getters.loader('initial') },
  },
  methods: {
    acceptConfirmDialog () {
      this.confirmDialogOptions.callback()
      this.confirmDialogOptions = null
    },
    selectPatchFromPicker (patch) {
      this.showPatchPickerFor(patch)
      this.showPatchPickerFor = null
    },
  },
  created () {
    this.$onBus('ask-confirmation',
      /** @param { {caption: string, message: string, component: ?object, callback: Function} } dialogOptions - Options to create the modal */
      (dialogOptions) => { this.confirmDialogOptions = dialogOptions })
    this.$onBus('display-information',
      /** @param {{ caption: string, message: string, acceptable: boolean, rejectable: boolean }} dialogOptions - Options to create the modal */
      (dialogOptions) => { this.informationModalOptions = dialogOptions })

    // Family events
    this.$onBus('edit-family',
      /** @param {Family|null} [family] - Family to edit. Leave blank to create a new one */
      (family = null) => { this.showFamilyFormFor = family })

    // Genus events
    this.$onBus('edit-genus',
      /** @param {Genus|null} [genus] - Genus to edit. Leave blank to create a new one */
      (genus = null) => { this.showGenusFormFor = genus })

    // Resource events
    this.$onBus('edit-resource',
      /** @param {Resource|null} [resource] - Resource to edit. Leave blank to create a new one */
      (resource = null) => { this.showResourceFormFor = resource })
    this.$onBus('edit-resource-interactions-group',
      /** @param {ResourceInteractionsGroup|null} resourceInteractionsGroup - Resource interaction group to edit/create */
      (resourceInteractionsGroup = null) => { this.showResourceInteractionsGroupFormFor = resourceInteractionsGroup })
    this.$onBus('show-resource-description',
      /** @param {Resource} resource - Resource to display */
      (resource) => { this.showResourceDescriptionFor = resource })
    this.$onBus('show-resource-note-form',
      /** @param {ResourceNote|object} resourceNote - Resource descripiton to edit/create */
      (resourceNote) => { this.showResourceNoteFormFor = resourceNote })
    this.$onBus('show-resource-interaction-form',
      /** @param {{resourceInteraction: ResourceInteraction | null, resourceId: number | null}} resourceInteraction - Resource interaction to edit/create */
      (resourceInteraction) => { this.showResourceInteractionFormFor = resourceInteraction })

    // Map events
    this.$onBus('show-map-notes-form',
      /** @param {Map} map - Map to edit */
      (map) => { this.showMapNotesFormFor = map })

    // Layer events
    this.$onBus('show-layer-form',
      /** @param {Layer|null} [layer] - Layer to edit. Leave blank to create a new one */
      (layer = null) => { this.showLayerFormFor = layer })

    // Element events
    this.$onBus('show-element-form',
      /** @param {Element} element - Element to modify */
      (element) => { this.showElementFormFor = element })
    this.$onBus('show-implantation-form',
      /** @param {Element} element - Element to modify */
      (element) => { this.showImplantationFormFor = element })
    this.$onBus('show-removal-form',
      /** @param {Element} element - Element to modify */
      (element) => { this.showRemovalFormFor = element })

    // Patch events
    this.$onBus('show-patch-form',
      /** @param {Patch} patch - Patch to modify */
      (patch) => { this.showPatchFormFor = patch })
    this.$onBus('show-patch-resource-picker',
      /** @param {Patch} patch - Target patch */
      (patch) => { this.showResourcePickerFor = patch })
    this.$onBus('show-resource-patch-picker',
      /** @param {showPatchPickerCallback} callback - Callback to execute when resource is picked */
      (callback) => { this.showPatchPickerFor = callback })
    // Path events
    this.$onBus('show-path-form',
      /** @param {Path} path - Path to modify */
      (path) => { this.showPathFormFor = path })

    // Observation events
    this.$onBus('show-observation-form',
      /** @param {Element|Map|Patch|Path|Observation} subject - Subject entity or observation */
      (subject) => { this.showObservationFormFor = subject })
    this.$onBus('show-observations',
      /** @param {Element|Map|Path|Patch|null} subject - Subject for which to show observations */
      (subject = null) => { this.showObservationsFor = subject })

    // Harvest events
    this.$onBus('show-harvest-form',
      /** @param { Harvest | object | null } harvest - Harvest entity */
      (harvest) => { this.showHarvestFormFor = harvest })
    this.$onBus('show-harvests',
      /** @param {Element | null} element - Element entity */
      (element = null) => { this.showHarvestsFor = element })

    // Tasks events
    this.$onBus('show-task-form',
      /** @param {Element|Map|Patch|Path} subject - Subject entity */
      (subject) => { this.showTaskFormFor = subject })

    // Picture-lists events
    this.$onBus('show-image',
      /** @param {{selected: string, list: string[]}} images - Widget configuration */
      (images) => {
        this.imagesList = images.list
        this.imageToDisplay = images.selected
      })

    // Notifications
    this.$onBus('show-notifications',
      () => { this.showNotificationsModal = true })

    this.$store.dispatch('loadGroup', {
      name: 'initial',
      loaders: [
        {
          promise: this.$store.dispatch('loadAccount'),
          message: this.$t('js.loaders.loading_account'),
        },
        {
          promise: this.$store.dispatch('loadMaps'),
          message: this.$t('js.loaders.loading_maps'),
        },
        {
          promise: this.$store.dispatch('loadFamilies'),
          message: this.$t('js.loaders.loading_families'),
        },
        {
          promise: this.$store.dispatch('loadGenera'),
          message: this.$t('js.loaders.loading_genera'),
        },
        {
          promise: this.$store.dispatch('loadResources'),
          message: this.$t('js.loaders.loading_resources'),
        },
        {
          promise: this.$store.dispatch('loadResourceInteractionsGroups'),
          message: this.$t('js.loaders.loading_resource_interactions_groups'),
        },
        {
          promise: this.$store.dispatch('loadResourceInteractions'),
          message: this.$t('js.loaders.loading_resource_interactions'),
        },
        {
          promise: this.$store.dispatch('loadNotifications'),
          message: this.$t('js.loaders.loading_notifications'),
        },
      ],
    })
      .then(() => {
        const preferences = this.$store.getters.account.preferences
        // Redirect before declaring the map as ready
        if (preferences.map && this.$route.name === 'maps') {
          this.$router.push({ name: 'map', params: { mapId: preferences.map } })
            .then(() => { this.ready = true })
        } else {
          this.ready = true
        }
      })
  },
}
</script>
